// AbstractUIElement.h: interface for the CAbstractUIElement class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ABSTRACTUIELEMENT_H__54270940_B805_11D6_BD14_A5402071EB3A__INCLUDED_)
#define AFX_ABSTRACTUIELEMENT_H__54270940_B805_11D6_BD14_A5402071EB3A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <D3D8.h>
#include "customvertex.h"

class CAbstractUIElement  
{
public:
    CAbstractUIElement() {}
    virtual ~CAbstractUIElement() {}

    //User Input Functions
    virtual void OnMouseMove(const POINT& mousepos, const TransformMatrices* transmats) {}
    virtual void OnLButtonDown(const POINT& mousepos, const TransformMatrices* transmats) {}
    virtual void OnLButtonUp(const POINT& mousepos, const TransformMatrices* transmats) {}

    //Drawing and Animation Functions
    virtual HRESULT Render(const D3DXMATRIX &matWorld) = 0;
    virtual HRESULT FrameMove(const POINT& mousepos, const TransformMatrices* transmats) { return S_OK; };

    //DirectX Device Object Functions
    virtual HRESULT InitDeviceObjects(LPDIRECT3DDEVICE8 pd3dDevice) = 0;
    virtual HRESULT RestoreDeviceObjects() = 0;
    virtual HRESULT InvalidateDeviceObjects() = 0;
    virtual HRESULT DeleteDeviceObjects() = 0;
};

#endif // !defined(AFX_ABSTRACTUIELEMENT_H__54270940_B805_11D6_BD14_A5402071EB3A__INCLUDED_)
