// MenuItem.h: interface for the CMenuItem class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MENUITEM_H__FEE15941_BA11_11D6_BD14_A311A842393D__INCLUDED_)
#define AFX_MENUITEM_H__FEE15941_BA11_11D6_BD14_A311A842393D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "AbstractUIElement.h"
#include <D3DX8.h>

class CMenuItem : public CAbstractUIElement   
{
public:
	CMenuItem();
	virtual ~CMenuItem();

    //returns whether the screen coords are in bounds of the item
    virtual BOOL IsInBounds(const POINT& mousepos,
                            const TransformMatrices* transmats);

    //User Input Functions
    virtual void OnMouseMove(const POINT& mousepos);
    virtual void OnLButtonDown(const POINT& mousepos);
    virtual void OnLButtonUp(const POINT& mousepos);

    //Drawing and Animation Functions
    virtual HRESULT Render(const D3DXMATRIX &matWorld);
    virtual HRESULT FrameMove(const POINT& mousepos,
                              const TransformMatrices* transmats);

    //DirectX Device Object Functions
    virtual HRESULT InitDeviceObjects(LPDIRECT3DDEVICE8 pd3dDevice);
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();

protected:
    LPDIRECT3DDEVICE8       m_pd3dDevice;           // A D3DDevice used for rendering
    LPDIRECT3DTEXTURE8      m_pItemTexture;
    LPDIRECT3DVERTEXBUFFER8 m_pItemVB;
};

#endif // !defined(AFX_MENUITEM_H__FEE15941_BA11_11D6_BD14_A311A842393D__INCLUDED_)
