// customvertex.h: holds all of the flexible vertex formats
//
//////////////////////////////////////////////////////////////////////

#if !defined(CUSTOMVERTEX_INCLUDED_)
#define CUSTOMVERTEX_INCLUDED_

#include <D3dx8math.h>

// Custom vertex type for the particles
struct PARTICLEVERTEX
{
    FLOAT       x, y, z; // Vertex position
    DWORD       color;   // Vertex color
    FLOAT       tu, tv;  // Vertex texture coordinates
};

#define D3DFVF_PARTICLEVERTEX (D3DFVF_XYZ|D3DFVF_DIFFUSE|D3DFVF_TEX1)

//struct to store the transformation matrices
//because Get* calls don't work with pure device
struct TransformMatrices
{
    D3DVIEWPORT8 viewport;
    D3DXMATRIX   matProj;
    D3DXMATRIX   matWorld;
    D3DXMATRIX   matView;
};

#endif // !defined(CUSTOMVERTEX_INCLUDED_)
